temp=read.csv("IS_CA.csv",header=TRUE)
head(temp)
summary(temp)
library(fBasics)

myData=na.omit(temp)
basicStats(myData[,1:3])["Sum",]
basicStats(myData[,1:3])[9,]
colStats(myData[,1:3],mean)
colMeans(myData[,1:3])
skewness(myData[,1:3])
kurtosis(myData[,1:3])
cov(myData[,1:3])
var(myData[,1:3])
cor(myData[,1:3])

FH_1vlm=lm(INVEST~SAVING, data=myData)
summary(FH_1vlm)

confint(FH_1vlm, level=0.9)

library(ellipse)
plot(ellipse(FH_1vlm,c(1,2)),type="l")
points(coef(FH_1vlm)[1], coef(FH_1vlm)[2], pch=13)
abline(v=confint(FH_1vlm)[1,], lty=2)
abline(h=confint(FH_1vlm)[2,], lty=2)


names(FH_1vlm)
names(summary(FH_1vlm))
FH_1vlm$coef
summary(FH_1vlm)$coef

with(plot(SAVING, INVEST),data=myData)
abline(FH_1vlm)
AIC(FH_1vlm)
BIC(FH_1vlm)
cbind(AIC(FH_1vlm), BIC(FH_1vlm))
rbind(AIC(FH_1vlm), BIC(FH_1vlm))
anova(FH_1vlm)

par(mfrow=c(2,2))
plot(FH_1vlm)
par(mfrow=c(1,1)

FH_pred=predict(FH_1vlm, interval="confidence")
with(plot(INVEST~SAVING),data=myData)
abline(FH_1vlm)
with(lines(FH_pred[,2] ~ SAVING, lwd=0.1, lty=4, col=2),data=myData)
with(lines(FH_pred[,3] ~ SAVING, lwd=0.1, lty=4, col=2),data=myData)
legend("topleft", c("regression line", "low", "upper"), lty=c(1,4,4), lwd=0.1, bty="n")

library(car)
linearHypothesis(FH_1vlm, "SAVING=0.2")


FH_2vlm=lm(INVEST~SAVING +CA, data=myData)
summary(FH_2vlm)
anova(FH_1vlm, FH_2vlm)
linearHypothesis(FH_2vlm, "SAVING+CA=0")

FH_2v2m=lm(INVEST~SAVING+I(SAVING^2), data=myData)
summary(FH_2v2m, corr =TRUE)

summary(lm(INVEST ~poly(SAVING, 2), data=myData), corr =TRUE)

FH_3vlm=lm(INVEST ~ SAVING+Group, data=myData)
print(summary(FH_3vlm),2)
linearHypothesis(FH_3vlm, "SAVING=0")
library(lmtest)
waldtest(FH_3vlm, .~. -SAVING)

FH_4vlm=lm(INVEST ~ SAVING + Group + Group*SAVING, data=myData)
summary(FH_4vlm)


summary(lm(INVEST ~ SAVING + Group + Group:SAVING, data=myData))
summary(lm(INVEST ~ SAVING + Group + Group/SAVING, data=myData))
summary(lm(INVEST ~ (Group + SAVING)^2, data=myData))

gqtest(FH_2vlm, order.by=~SAVING, data=myData) 
bptest(FH_2vlm, data=myData)

library(sandwich)
coeftest(FH_2vlm)
coeftest(FH_2vlm, vcovHC)
coeftest(FH_2vlm, vcov = vcovHC(FH_2vlm, type = "HC0"))


resettest(FH_2vlm, data=myData) 
raintest(FH_2vlm, order.by=~SAVING, data=myData)
harvtest(FH_2vlm, data=myData)

myTS=read.csv("taiwan3v.csv")
head(myTS)
myTS_Dates=ts(myTS, start=c(1962,1), freq=4)
head(myTS_Dates)
library(dynlm)
dynlm_twn=dynlm(Growth ~ L(Growth) + L(Growth, 4),data=myTS_Dates)
summary(dynlm_twn)
plot(dynlm_twn$resid)



data("CPS1985", package="AER")
head(CPS1985)
g=lm(wage ~ education + experience + age, data=CPS1985)
summary(g)
DAAG:::vif(g)
library(DAAG)
vif(g)

x=rnorm(150)
y=0.5-0.25*x+rnorm(100)*0.2
plot(x,y,xlab="ܼ")
abline(lm(y~x),col=2,lwd=3)



library(papeR)
prettify(summary(FH_1vlm))


write.csv(summary(myData)$coef,file="table0.csv")