library(plm)
temp1=read.csv("productivity.csv")
myData1= plm.data(temp1, index = c("state", "year"))
head(myData1)


y=myData1[,3]
x1=myData1[,4]
x2=myData1[,5]
x3=myData1[,6]
x4=myData1[,7]
x5=myData1[,8]
x6=myData1[,9]

###################################################
### Pooled OLS
###################################################
gsp_pool0 = plm(y~ x1+x2+x3+x4+x5+x6, data = myData1, model = "pooling")
summary(gsp_pool0)
###################################################
### Fixed Effects by LSDV
###################################################
gsp_fe0 = plm(y~ x1+x2+x3+x4+x5+x6, data = myData1, model = "within")
summary(gsp_fe0)

###################################################
### Formula Inputting
###################################################
Lhs= names(myData1)[3]
Rhs= paste(names(myData1)[4:9],collapse="+")
myEq=paste(Lhs, Rhs, sep="~")
myFormula=as.formula(myEq)
myFormula
gsp_pool = plm(myFormula, data = myData1, model = "pooling")
summary(gsp_pool)
gsp_fe=plm(myFormula, data = myData1, model = "within")
summary(gsp_fe)

###################################################
### Prettify Coefficient Matrix
###################################################
estimates_pool=as.data.frame(summary(gsp_pool)$coef)
papeR:::prettify(estimates_pool)

###################################################
### Fixed Effects by GLS
###################################################

gsp_poolFGLS=pggls(myFormula, data = myData1, model = "pooling")
summary(gsp_poolFGLS)

gsp_feFGLS=pggls(myFormula, data = myData1, model = "within")
summary(gsp_feFGLS)

gsp_reFGLS=pggls(myFormula, data = myData1, model = "random")
summary(gsp_reFGLS)

###################################################
### Random Effects by GLS
###################################################

gsp_re = plm(myFormula, data = myData1, model = "random", random.method = "swar")
summary(gsp_re)

###################################################
### Random Effects by MLE
###################################################
gsp_reML<-lme(myFormula,data=temp1,random=~1|state|year)

summary(gsp_reML)
summary(gsp_reML)$tTable
summary(gsp_reML)$logLik
summary(gsp_reML)$AIC
summary(gsp_reML)$BIC
summary(gsp_reML)$coef$random



names(summary(gsp_reML))
names(gsp_reML)
names(summary(gsp_reML)$coef)


















