library(plm)
###################################################
### Code chunk 1: IV estimator
###################################################
temp1 = read.csv("crime.csv")
head(temp1)
mydata1.pd= plm.data(temp1, index = c("county","year"))
head(mydata1.pd)
pdim(mydata1.pd)

myformulaIV=as.formula(log(crmrte) ~ log(prbarr) + log(polpc) + log(prbconv) +log(prbpris) + log(avgsen) + log(density) + log(wcon) + log(wtuc) +log(wtrd) + log(wfir) + log(wser) + log(wmfg) + log(wfed) +log(wsta) + log(wloc) + log(pctymle) + log(pctmin) + region +smsa + factor(year)|. -log(prbarr)-log(polpc)+log(taxpc)+log(mix))
out_IV=plm(myformulaIV , data = mydata1.pd, model = "random",inst.method = "baltagi")
summary(out_IV)
#inst.method = c("bvk","baltagi"),

###################################################
### Code chunk 2: Hausman-Taylor estimator
###################################################
temp2 = read.csv("Wages.csv")
head(temp2)
mydata2.pd= plm.data(temp2, index = c("ID","year"))
head(mydata2.pd)
pdim(mydata2.pd)

myFormulaHT=as.formula(lwage ~ wks + south + smsa + married + exp + I(exp^2)+bluecol + ind + union + sex + black + ed | sex + black +bluecol + south + smsa + ind)

out_ht=plm(myFormulaHT, model="ht",data = mydata2.pd)
summary(out_ht)

# T.V. exo : bluecol,south,smsa,ind
# T.V. endo : wks,married,exp,I(exp^2),union
# T.I. exo : sex,black
# T.I. endo : ed




