
# Unit root tests
library(urca)
temp=read.csv("tw_inf.csv")
head(temp)
inf=ts(temp[,2], start=c(1982,1),freq=12)
y.df=ur.df(inf, type=c("trend"),selectlags = "AIC")
summary(y.df)
plot(y.df)

y.pp=ur.pp(inf, type="Z-tau", model="trend", lags="long")
summary(y.pp)
show(y.pp)
plot(y.pp)

y.ers= ur.ers(inf, type="DF-GLS", model="const", lag.max=4)
summary(y.ers)
plot(y.ers)

y.kpss = ur.kpss(inf, type="tau", lags="long") # "mu" or "tau"
summary(y.kpss)
plot(y.kpss)

y.za = ur.za(inf, model="intercept", lag=8) # "mu" or "tau"
summary(y.za)
plot(y.za)



### To Simulate an I(1) process    
set.seed = 101
corr=0	# Residuals with AR(1) coefficient
T=1000		#Sample size
err=filter(rnorm(T), filter=corr, method = "recursive")
RW=rnorm(1);for (i in 2:T) {RW[i]=RW[i-1]+err[i]};plot.ts(RW,ylab="",xlab="",main="Simulated I(1) process")

