
library(XLConnect)
temp0 = loadWorkbook("inf.xls")
temp = readWorksheet(temp0, "Q")
head(temp)
myD=ts(temp[,-1],start=c(1971,1),freq=4)
head(myD)

library(plm)

# Case 1: cross-section independence
## data format 1: data is T by N matrix
out1 = purtest(myD,exo = "intercept", test="ips", pmax=10)
print(summary(out1),digits=2)
names(summary(out1))

write.csv(print(summary(out1)$sumidres,digits=2),file="table.csv")

## data format 2: data is T by N stacked vector
stack_data=stack(temp, select=-Quarter)
head(stack_data)
stack_pdata=pdata.frame(stack_data,index="ind")
pdim(stack_pdata)
out2 = purtest(values~1,data=stack_pdata, test="ips", pmax=10)
summary(out2)

#test= c("levinlin", "ips", "madwu", "hadri")
#exo = c("none", "intercept", "trend")
#lags = c("SIC", "AIC", "Hall")


# Case 2: cross-section dependency

## testing CD

dat=plm.data(stack_data,index="ind")
head(dat)
pdim(dat)
pcdtest(values~1, model="pooling",data=dat,test="sclm")
out3=plm(values~1, model="pooling", data=dat)
pcdtest(out3,test="sclm")
# test=c("cd","sclm","lm")


temp=read.csv("Grunfeld.csv")
dataz=plm.data(temp,index=c("firm","year"))
pdim(dataz)
out_plm=plm(inv~value+capital, data=dataz, model = "within")
pcdtest(out_plm)
pcdtest(inv~value+capital, data=dataz, model = "within")
pcdtest(inv~value+capital,data=dataz, model = "random", effect = "twoways")



##CIPS
cips_out=cipstest(stack_pdata$values,lags = 10, type="drift",model = "cmg")
print(cips_out)

#model = c("cmg","mg","dmg")
#type=c("trend", "drift", "none")









data("Produc")
ccepmod <- pccep(log(gsp) ~ log(pcap) + log(pc) + log(emp) + unemp, data = Produc)
summary(ccepmod)