###################################################
### Code chunk 0: plm-data
###################################################
temp = read.csv("retVol.csv")
mydata=na.omit(temp)
head(mydata)
library(plm)
mydata.pd= plm.data(mydata, index = c("ID","DATEID"))
head(mydata.pd)
pdim(mydata.pd)

myFormula=RET ~ STD + log(VOLUMN)
out1_FE=plm(myFormula, data=mydata.pd)
out2_FE=plm(myFormula, data=mydata.pd,effect="twoways")
coef(summary(out1_FE))
coef(summary(out2_FE))
###################################################
### Code chunk 1: pmg
###################################################
# M. Hashem Pesaran, (2006), Estimation and Inference in Large
# Heterogeneous Panels with a Multifactor Error Structure,
# Econometrica, 74(4), 967V1012.

##  Mean Groups
mgmod = pmg(myFormula, data = mydata.pd)
summary(mgmod)
## demeaned Mean Groups
dmgmod = pmg(myFormula, data = mydata.pd, model="dmg")
summary(dmgmod)
## Common Correlated Effects Mean Groups
ccemgmod = pmg(myFormula, data = mydata.pd, model="cmg")
summary(ccemgmod)

###################################################
### Code chunk 2: PCCEP
###################################################
# Kapetanios G., M. Hashem Pesaran, T. Yamagata (2011), 
# Panels with non-stationary multifactor error structures, 
# Journal of Econometrics, 160(2), 326V348.

temp1=read.csv("Produc.csv")
head(temp1)
mydata2.pd=plm.data(temp1, index=c("state","year"))
myForm=log(gsp) ~ log(pcap) + log(pc) + log(emp) + unemp
ccepmod = pccep(myForm, data = mydata2.pd, residuals = "standard")
summary(ccepmod)

###################################################
### Code chunk 3: Variable Coefficients Models
###################################################

pvcm_FE = pvcm(myFormula, data = mydata.pd, model = "within")
summary(pvcm_FE)
pvcm_RE = pvcm(myFormula, data = mydata.pd, model = "random")
summary(pvcm_RE)


summary(pvcm_FE)$coef[,2:3]
out.tmp=t(summary(ccemgmod)$indcoef)[,2:3]
rownames(out.tmp)=unique(mydata.pd$ID)
out.tmp




