library(pglm)
##===== Binomial (logit) example
DataUnion<- read.csv("union.csv")
head(DataUnion)
myForm1<-union~age+grade+not_smsa+south
out_logit <- pglm(myForm1, family=binomial("logit"), data=DataUnion,index="idcode")
summary(out_logit)

out_probit <- pglm(myForm1, family=binomial("probit"), data=DataUnion,index="idcode");summary(out_probit)

outP_probit <- pglm(myForm1, family=binomial("probit"),model="pooling", data=DataUnion,index="idcode")
summary(outP_probit)

library(car)
linearHypothesis(outUnion,c("not_smsa=0", "south=0"))

##===== Poisson count data models
DataShips<- read.csv("ships.csv")
head(DataShips)
myForm2<-accident~op_75_79+co_65_69+co_70_74+co_75_79+offset(service)
outShip <- pglm(myForm2,family=poisson,data=DataShips,index="ship")
summary(outShip)

##===== Negative Binomial count data models
DataAiracc<- read.csv("airacc.csv")
head(DataAiracc,10)
out_airacc<- pglm(i_cnt~inprog,family=negbin,R=6,data=DataAiracc,index="airline")
summary(out_airacc)


